function [N] = legendre_basis(X,Nd,DIF)
%HERMITE_BASIS returns "DIF"-th differential of Hermite basis at X

if Nd==2
if DIF==0
    
    N=[ 1;
        X];

elseif DIF==1
    
    N=[ 0;
        1];

else
    
    N=zeros(2,1);
    
end

elseif Nd==3
if DIF==0
    
    N=[ 1;
        X;
        (3*X^2-1)/2];

elseif DIF==1
    
    N=[ 0;
        1;
        3*X];

elseif DIF==2
    
    N=[ 0;
        0;
        3;];
else
    N=zeros(3,1);
  
end
elseif Nd==4
if DIF==0
    
    N=[ 1;
        X;
        (3*X^2-1)/2
        (5*X^3-3*X)/2];

elseif DIF==1
    
    N=[ 0;
        1;
        3*X;
        (15*X^2-3)/2];

elseif DIF==2
    
    N=[ 0;
        0;
        3;
        15*X];
elseif DIF==3
    
    N=[ 0;
        0;
        0;
        15];
else
    
    N=zeros(4,1);
    
end


end

end

