function [M,C,K] = mk_MCKmatrix(Nd,dx)
%MK_MCKMATRIX 

INT = 10;
[P,W]=lgwt(INT,-1,1);

M = zeros(Nd,Nd);
C = zeros(Nd,Nd);
K = zeros(Nd,Nd);

for kk=1:INT
    NVEC = legendre_basis(P(kk),Nd,0);
    dNdX = legendre_basis(P(kk),Nd,1);
%     dNdX2= legendre_basis(P(kk),Nd,2);
    
    M=M+W(kk)*NVEC*NVEC'*dx/2;
    C=C+W(kk)*dNdX*NVEC';
    K=K+W(kk)*dNdX*dNdX'/(dx/2);
end

